---
title: Intl.Collator
slug: Web/JavaScript/Reference/Global_Objects/Intl/Collator
tags:
  - Class
  - Collator
  - Internationalization
  - Intl
  - JavaScript
---
<div>{{JSRef}}</div>

<p>The <strong><code>Intl.Collator</code></strong> objects enable language sensitive string comparison.</p>

<div>{{EmbedInteractiveExample("pages/js/intl-collator.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Constructor">Constructor</h2>

<dl>
 <dt>{{jsxref("Intl/Collator/Collator", "Intl.Collator()")}}</dt>
 <dd>Creates a new <code>Collator</code> object.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl>
 <dt>{{jsxref("Collator.supportedLocalesOf", "Intl.Collator.supportedLocalesOf()")}}</dt>
 <dd>Returns an array containing those of the provided locales that are supported without having to fall back to the runtime's default locale.</dd>
</dl>

<h2 id="Instance_methods">Instance methods</h2>

<dl>
 <dt>{{jsxref("Collator.compare", "Intl.Collator.prototype.compare")}}</dt>
 <dd>Getter function that compares two strings according to the sort order of this {{jsxref("Global_Objects/Collator", "Intl.Collator")}} object.</dd>
 <dt>{{jsxref("Collator.resolvedOptions", "Intl.Collator.prototype.resolvedOptions()")}}</dt>
 <dd>Returns a new object with properties reflecting the locale and collation options computed during initialization of the object.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_Collator">Using Collator</h3>

<p>The following example demonstrates the different potential results for a string occurring before, after, or at the same level as another:</p>

<pre class="brush: js notranslate">console.log(new Intl.Collator().compare('a', 'c')); // → a negative value
console.log(new Intl.Collator().compare('c', 'a')); // → a positive value
console.log(new Intl.Collator().compare('a', 'a')); // → 0
</pre>

<p>Note that the results shown in the code above can vary between browsers and browser versions. This is because the values are implementation-specific. That is, the specification requires only that the before and after values are negative and positive.</p>

<h3 id="Using_locales">Using locales</h3>

<p>The results provided by {{jsxref("Collator.prototype.compare()")}} vary between languages. In order to get the sort order of the language used in the user interface of your application, make sure to specify that language (and possibly some fallback languages) using the <code><var>locales</var></code> argument:</p>

<pre class="brush: js notranslate">// in German, ä sorts with a
console.log(new Intl.Collator('de').compare('ä', 'z'));
// → a negative value

// in Swedish, ä sorts after z
console.log(new Intl.Collator('sv').compare('ä', 'z'));
// → a positive value
</pre>

<h3 id="Using_options">Using options</h3>

<p>The results provided by {{jsxref("Collator.prototype.compare()")}} can be customized using the <code><var>options</var></code> argument:</p>

<pre class="brush: js notranslate">// in German, ä has a as the base letter
console.log(new Intl.Collator('de', { sensitivity: 'base' }).compare('ä', 'a'));
// → 0

// in Swedish, ä and a are separate base letters
console.log(new Intl.Collator('sv', { sensitivity: 'base' }).compare('ä', 'a'));
// → a positive value
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ES Int Draft', '#collator-objects', 'Intl.Collator')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Intl.Collator")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Intl">Intl</a></code></li>
</ul>
